package jumbo.xml;

import java.awt.BorderLayout;

import com.sun.java.swing.JComponent;
import com.sun.java.swing.JPanel;
import com.sun.java.swing.JSplitPane;

import jumbo.xml.gui.TabbedPane;
import jumbo.xml.gui.XSplitPanePanel;

/** a simple class providing a JPanel to hold a node's content
@author P.Murray-Rust, 1998
*/
public class XNodePanel extends JPanel {
	TabbedPane tabbedPane;
	XTree xTree = null;
/** a default XNodePanel
*/
	public XNodePanel(XTree xTree) {
		super();
		initialise(xTree);
	}

	void initialise(XTree xTree) {
		tabbedPane = new TabbedPane();
		this.setLayout(new BorderLayout());
		this.add(tabbedPane, BorderLayout.CENTER);
		this.xTree = xTree;
	}
	
/** add an XNode to the panel. 
@param xNode the XNode to be added
*/
	public void addXNode(XNode xNode) {
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(xNode.getDisplayComponent(XNode.ELEMENTNAME), BorderLayout.NORTH);
		JComponent attributePanel = xNode.getDisplayComponent(XNode.ATTRIBUTES);
		if (attributePanel == null) {
			System.out.println("Null attribute panel: "+xNode);
			return;
		}
		TabbedPane contentTabbedPane = new TabbedPane();
		XSplitPanePanel xsp = new XSplitPanePanel
			(JSplitPane.VERTICAL_SPLIT, attributePanel, contentTabbedPane);
		panel.add(xsp, BorderLayout.CENTER);
		String title = xNode.getTitle();
		String toolTip = xNode.toString();
		tabbedPane.add(panel, title, toolTip);

		for (int i = XNode.XMLCONTENT; i < XNode.nComponentTypes; i++) {
			if (xTree.contentDisplayRadioButton[i].isSelected()) {
				String s = XNode.displayTypeStrings[i];
				contentTabbedPane.add(xNode.getDisplayComponent(i), s, s);
			}
		}
	}
}